package com.gic.haoban.manage.service.service.out.impl;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gic.wechat.api.service.qywx.QywxUserApiService;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.commons.util.MD5Utils;
import com.gic.commons.util.Md5Util;
import com.gic.commons.util.StringUtil;
import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;
import com.gic.haoban.manage.api.dto.StaffDepartmentRelatedDTO;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.StaffDepartmentRelatedApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseApiService;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterprise;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterpriseRelated;
import com.gic.haoban.manage.service.service.MemberUnionRelatedService;
import com.gic.haoban.manage.service.service.StaffService;
import com.gic.haoban.manage.service.service.WxEnterpriseRelatedService;
import com.gic.haoban.manage.service.service.WxEnterpriseService;
import com.gic.haoban.manage.service.util.EmojiFilterUtil;
import com.gic.member.api.dto.MemberDTO;
import com.gic.member.api.service.MemberOpenCardBusinessService;
import com.gic.member.api.service.MemberService;
import com.gic.redis.data.anno.RedisLock;
import com.gic.redis.data.util.RedisUtil;

@Service
public class MemberUnionidRelatedApiServiceImpl implements MemberUnionidRelatedApiService{
	private static final Logger log = LogManager.getLogger(MemberUnionidRelatedApiServiceImpl.class);
	@Autowired
	private MemberUnionRelatedService memberUnionRelatedService;
	@Autowired
	private StaffService staffService;
	@Autowired
	private QywxUserApiService qywxUserApiService;
	@Autowired
	private com.gic.enterprise.api.service.StoreGroupService gicDepartmentService;
	@Autowired
	private MemberService memberService;
	@Autowired
	private WxEnterpriseRelatedService wxEnterpriseRelatedService;
	@Autowired
	private WxEnterpriseService wxEnterpriseService;
	
	private static final String SELF_APP = "selfSuiteId";
	
	@Autowired
	private MemberOpenCardBusinessService memberOpenCardBusinessService;
	
	@Autowired
	private StaffDepartmentRelatedApiService staffDepartmentRelatedApiService;
	@Autowired
	private ClerkService clerkService;
	@Autowired
	private DepartmentApiService departmentApiService;


	@Override
	public MemberUnionidRelatedDTO getByUnionId(String staffId, String unionid) {
		TabHaobanStaff staff = staffService.selectById(staffId);
		if(staff == null){
			return null;
		}
		log.info("【查询会员】wxUserId={},unionid={}",staff.getWxUserId(),unionid);
		return memberUnionRelatedService.getByUnionId(staff.getWxUserId(),unionid);
	}
	@Override
	public String addMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		log.info("【新增外部联系人回调】dto={}",JSON.toJSONString(dto));
		String corpId = dto.getCorpid();
		TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(corpId);
		if(wxEnterprise == null){
			return "";
		}
		List<TabHaobanWxEnterpriseRelated> list = wxEnterpriseRelatedService.getByWxEnterpriseId(wxEnterprise.getWxEnterpriseId());
		String suiteid = dto.getSuiteid();		
		String unionIdJson = "";
		if(SELF_APP.equals(suiteid)){
			unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(dto.getCorpid(), wxEnterprise.getWxSecretKey(), dto.getExternalUserid());
		}else{
			unionIdJson = qywxUserApiService.getExternalUseridInfo(dto.getCorpid(), dto.getSuiteid(), dto.getExternalUserid());
		}
		String userId1 = dto.getWxUserId();
		
		log.info("【新增外部联系人回调】unionIdJson={}",JSON.toJSONString(unionIdJson));
		String unionId = "";
		String name = "";
		String follow_user = "";
		String createTime  = "";
		String userId = "";
		String avatar = "";
		String relaName = "";
		if(StringUtils.isNotBlank(unionIdJson)){
			JSONObject jo = JSON.parseObject(unionIdJson);
			String external_contact  = jo.getString("external_contact");
			if(StringUtils.isNotBlank(external_contact)){
				JSONObject jt = JSON.parseObject(external_contact);
				unionId = jt.getString("unionid");
				name = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
				relaName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
				avatar = jt.getString("avatar");
			}
			
			follow_user = jo.getString("follow_user");
			if(StringUtils.isNotBlank(follow_user)){
				JSONArray j = JSON.parseArray(follow_user);
				for (Object object : j) {
					String followJson = JSON.toJSONString(object);
					JSONObject follow = JSON.parseObject(followJson);
					userId = follow.getString("userid");
					if(userId.equals(userId1)){
						createTime = follow.getString("createtime");
					}
				}
			}
		}
		
		
		
		for (TabHaobanWxEnterpriseRelated tabHaobanWxEnterpriseRelated : list) {
			String key = "external" + tabHaobanWxEnterpriseRelated.getEnterpriseId() + "_"+ userId1 + "_" + name + "_" + createTime;
			RedisUtil.lock(key,2l);
			dto.setWxEnterpriseId(tabHaobanWxEnterpriseRelated.getEnterpriseId());
			MemberDTO member = null;
			TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId1, tabHaobanWxEnterpriseRelated.getWxEnterpriseId());
			if(staff == null){
				continue;
			}
			if(SELF_APP.equals(suiteid)){
				List<StaffDepartmentRelatedDTO> relatedList = staffDepartmentRelatedApiService.listByStaffId(staff.getStaffId());
				log.info("【部门list】staffId={}",staff.getStaffId());
				List<StaffDepartmentRelatedDTO> rList = new ArrayList<StaffDepartmentRelatedDTO>();
				for (StaffDepartmentRelatedDTO staffDepartmentRelatedDTO : relatedList) {
					DepartmentDTO depart = departmentApiService.selectById(staffDepartmentRelatedDTO.getDepartmentId());
					log.info("【部门list】depart={},deparmentId={}",JSON.toJSONString(depart),staffDepartmentRelatedDTO.getDepartmentId());
					if(depart != null && tabHaobanWxEnterpriseRelated != null && depart.getEnterpriseId() != null && tabHaobanWxEnterpriseRelated.getEnterpriseId() != null){
						log.info("【部门list】enterpriseId={},enterpriseId2={}",depart.getEnterpriseId(),tabHaobanWxEnterpriseRelated.getEnterpriseId());
						if(depart.getEnterpriseId().equals(tabHaobanWxEnterpriseRelated.getEnterpriseId())){
							rList.add(staffDepartmentRelatedDTO);
						}
					}
				}
				log.info("【部门list】rList={}",JSON.toJSONString(rList));
				//DepartmentDTO departmentDTO =
				String clerkCode = "";
				if(!rList.isEmpty()){
					for (StaffDepartmentRelatedDTO staffDepartmentRelatedDTO : rList) {
						clerkCode = staffDepartmentRelatedDTO.getClerkCode();
						if(StringUtils.isNotBlank(clerkCode)){
							break;
						}
					}
				}
				ClerkDTO clerk = clerkService.getClerkByClerkCode(tabHaobanWxEnterpriseRelated.getEnterpriseId(), clerkCode);
				log.info("【新增外部联系人】clerkCode={}",clerkCode);
				if(clerk != null && StringUtils.isNotBlank(clerk.getQrcodeParam())){
					log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}",tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,name,avatar,clerk.getQrcodeParam());
					 member = memberOpenCardBusinessService.getMemberByQywxChannelParam(tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,"",relaName,avatar,clerk.getQrcodeParam());
				}
				log.info("【新增外部联系人】member={},clerk={}",JSON.toJSONString(member),JSON.toJSONString(clerk));
				if(member != null){
					dto.setMemberId(member.getMemberId());
				}
			}
			dto.setSelfExternalUserid(dto.getExternalUserid());
			dto.setUnionid(unionId);
			
			dto.setExternalName(name);
			dto.setAddCreateTime(createTime);
			if(StringUtils.isBlank(unionId)){
				return "";
			}
			
			dto.setSuiteid(wxEnterprise.getWxSecretKey());
			
			MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(dto.getWxUserId(), tabHaobanWxEnterpriseRelated.getEnterpriseId(),name,createTime);
			String uuid = "";
			if(exsitDTO == null){
				uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
			}else{
				//如果是自建更新uuid
				if(SELF_APP.equals(suiteid)){
					exsitDTO.setUnionid(unionId);
					exsitDTO.setMemberId(dto.getMemberId());
				}else{
					//更新对外联系人id
					exsitDTO.setExternalUserid(dto.getExternalUserid());
				}
				memberUnionRelatedService.update(exsitDTO);
				uuid = exsitDTO.getMemberUnionidRelatedId();
			}
		}
		
//		if(SELF_APP.equals(suiteid)){
//			MemberDTO member = null;
//			for (TabHaobanWxEnterpriseRelated tabHaobanWxEnterpriseRelated : list) {
//				TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId, tabHaobanWxEnterpriseRelated.getWxEnterpriseId());
//				if(staff == null){
//					continue;
//				}
//				List<StaffDepartmentRelatedDTO> relatedList = staffDepartmentRelatedApiService.listByStaffId(staff.getStaffId());
//				String clerkCode = "";
//				if(!relatedList.isEmpty()){
//					for (StaffDepartmentRelatedDTO staffDepartmentRelatedDTO : relatedList) {
//						clerkCode = staffDepartmentRelatedDTO.getClerkCode();
//						if(StringUtils.isNotBlank(clerkCode)){
//							break;
//						}
//					}
//				}
//				ClerkDTO clerk = clerkService.getClerkByClerkCode(tabHaobanWxEnterpriseRelated.getEnterpriseId(), clerkCode);
//				if(clerk != null){
//					log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}",tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,name,avatar,clerk.getQrcodeParam());
//					 member = memberOpenCardBusinessService.getMemberByQywxChannelParam(tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,null,name,avatar,clerk.getQrcodeParam());
//				}
//				log.info("【新增外部联系人】member={},clerk={}",JSON.toJSONString(member),JSON.toJSONString(clerk));
//				 //member = memberService.getMemberByUnionid(unionId, tabHaobanWxEnterpriseRelated.getEnterpriseId());
////				 if(member != null){
////					 break;
////				 }
//			}
//			if(member != null){
//				dto.setMemberId(member.getMemberId());
//			}
//			dto.setSelfExternalUserid(dto.getExternalUserid());
//			dto.setUnionid(unionId);
//		}
//		
//		dto.setExternalName(name);
//		dto.setAddCreateTime(createTime);
//		if(StringUtils.isBlank(unionId)){
//			return "";
//		}
//		
//		dto.setWxEnterpriseId(wxEnterprise.getWxEnterpriseId());
//		dto.setSuiteid(wxEnterprise.getWxSecretKey());
//		
//		MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(dto.getWxUserId(), wxEnterprise.getWxEnterpriseId(),name,createTime);
//		String uuid = "";
//		if(exsitDTO == null){
//			uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
//		}else{
//			//如果是自建更新uuid
//			if(SELF_APP.equals(suiteid)){
//				exsitDTO.setUnionid(unionId);
//				exsitDTO.setMemberId(dto.getMemberId());
//			}else{
//				//更新对外联系人id
//				exsitDTO.setExternalUserid(dto.getExternalUserid());
//			}
//			memberUnionRelatedService.update(exsitDTO);
//			uuid = exsitDTO.getMemberUnionidRelatedId();
//		}
		return "";
	}
	@Override
	public void delMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		memberUnionRelatedService.delMemberUnionidRelated(dto);
		
	}

	private void getExternalUserUnionid(MemberUnionidRelatedDTO dto){
		TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(dto.getCorpid());
		if(wxEnterprise == null){
			return ;
		}
		String externalUseridInfo = this.qywxUserApiService.getCorpSelfExternalUseridInfo(dto.getCorpid(), wxEnterprise.getWxSecretKey(), dto.getExternalUserid());
		if(StringUtils.isNotBlank(externalUseridInfo)){
			JSONObject jsonObject = JSON.parseObject(externalUseridInfo);
			dto.setUnionid(jsonObject.getString("unionid"));
		}
	}
	@Override
	public MemberUnionidRelatedDTO getByMemberId(String staffId, String memberId) {
		
		return null;
	}
	@Override
	public List<MemberUnionidRelatedDTO> getByWxUserIdAndWxEnterpriseId(String wxUserId, String wxEnterpriseId) {
		List<MemberUnionidRelatedDTO> list = memberUnionRelatedService.getByWxUserIdAndWxEnterpriseId(wxUserId,wxEnterpriseId);
		return list;
	}
}
